/*
 ATtiny25 nRF24L01 TX Test
 Version: 0.2
 Author: Alex from Inside Gadgets (http://www.insidegadgets.com)
 Created: 15/08/2012
 Last Modified: 19/09/2012
 
 Test the transmit/receive on an nRF24L01 with the ATtiny25
 
 */

#define F_CPU 1000000 // 1 MHz

#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/sleep.h>
#include "setup.c"
#include "mirf.c"

// ATtiny25/45/85 Pin map
//                        +-\/-+
// Reset/Ain0 (D 5) PB5  1|o   |8  Vcc
//  CE - Ain3 (D 3) PB3  2|    |7  PB2 (D 2) Ain1 - SCK
// CSN - Ain2 (D 4) PB4  3|    |6  PB1 (D 1) pwm1 - MO
//                  GND  4|    |5  PB0 (D 0) pwm0 - MI
//                        +----+

uint8_t data_in[1] = {0};
uint8_t data_out[1] = {1};

int main(void) {
	setup();
	mirf_init();
	_delay_ms(50);
	mirf_config();
	
	while(1) {
		// Sleep for 1 second
		setup_watchdog(T1S);
		system_sleep();
		turnOffwatchdog();
		
		// Check in with the server
		if (!check_in()) {
			for (int x = 0; x < 5; x++) {
				mirf_CSN_lo;
				_delay_ms(50);
				mirf_CSN_hi;
				_delay_ms(50);
			}
		}
	}
}

ISR(WDT_vect) { }
